//<script>
function SIMain() {
}

objSvc = null;;
SIMain.infoData = new Array();
SIMain.maxMesssages = 3;
SIMain.maxUpdates = 1;
SIMain.frameInited = new Object();
SIMain.dpiX = null;

SIMain.init = function() {
    window.external.ScriptHelper.SetTitle(SIConfig.appName);

    SIMain.dpiX = window.external.ScriptHelper.GetDpiX();
    if (SIMain.dpiX < 0 ) SIMain.dpiX = 96;

    SIMain.cursorWait(true);
    document.title = SIConfig.appName;
    SIWindow.setFontsToMatchDPI();
    SIWindow.init(true);
    var elem = document.getElementById('title');
    elem.innerHTML = SIConfig.appName;
    

    SIButton.createClipped("closebox", SIMain.closeAcion);
    SIButton.createClipped("minbox", SIMain.minAcion);    
    SIPaneTab.makeTabs();
    SIButton.createClipped("close", SIMain.closeAcion);
    SIMain.cursorWait(false);

    SIMain.setUpLinks();
    var elem = SIMain.getFrameElement('connect','connect'+'labGetting');
    elem.innerHTML = SIConfig.labGetting;

    setTimeout('SIMain.init1()',1);

}

SIMain.init1 = function() {
    objSvc = window.external.serviceManager;
    if (objSvc) {
        setTimeout('SIMain.init2()',1);
    }
    else {
        setTimeout('SIMain.init1()',3);
    }
}

SIMain.init2 = function() {
    SIButton.createClipped("openappfolder", SIMain.openAppFolder);
    SIButton.createClipped("opendatafolder", SIMain.openDataFolder);
    SIButton.createClipped("openquickrestore", SIMain.showQuick);
    SIButton.createClipped("search", SIMain.startSearch);
    SIButton.createClipped("cancel", SIMain.cancelSearch);
    
    SIButton.createClipped("clearCache", SIMain.actionHandler);
    SIButton.createClipped("openIOCP", SIMain.actionHandler);
    SIButton.createClipped("openTM", SIMain.actionHandler);
    SIButton.createClipped("openAR", SIMain.actionHandler);
    SIButton.createClipped("openDM", SIMain.actionHandler);
    SIButton.createClipped("openSM", SIMain.actionHandler);
    SIButton.createClipped("openNC", SIMain.actionHandler);
    SIButton.createClipped("openWU", SIMain.actionHandler);
    SIButton.createClipped("startRenew", SIMain.actionHandler);
    SIButton.createClipped("ping", SIMain.actionHandler);
    SIButton.createClipped("rebuild", SIMain.actionHandler);
    SIButton.createClipped("openDP", SIMain.actionHandler);
    SIButton.createClipped("closeaol", SIMain.actionHandler);
    SIButton.createClipped("openCU", SIMain.actionHandler);  
   
    SIButton.createClipped("createdialup", SIMain.createdialup);
    SIButton.createClipped("resetloc", SIMain.resetLoc);


    SIMain.callReadyFrames();
   
    if (SIMain.alert("ok", "cancel", "alertStartTitle", SIConfig["alertStartWarn"]) == "0") {
        SIMain.closeAcion();
    }       
}

SIMain.actionHandler = function(id) {
    if (SIMain[id]) {
        SIMain[id]();
    }    
}


SIMain.objectMap = new Object();
SIMain.iModemUserOnline = "";

SIMain.objectMapper = {
    'objSysHardware'  : 'systemHardware',
    'objSysSoftware'  : 'systemSoftware',
    'objAOLSoftware'  : 'aolSoftware',
    'objConnectivity' : 'connectivity',
    'objModems'       : 'modems',
    'objTools'        : 'tools',
    'objMinReq'       : 'hardwareMinReqChecker'    
}

SIMain.getObject = function(theObj) {
    var results = null;
    if (SIMain.objectMap[theObj]) {
        results = SIMain.objectMap[theObj];
    }
    else {
       try {
            results = objSvc.sysinfo[SIMain.objectMapper[theObj]];
            SIMain.objectMap[theObj] = results;
            if (theObj == 'objConnectivity') {
                results.initConnectivity();
            }
            if (theObj == 'objModems') {
                SIMain.iModemUserOnline = results.initModems();
            }
        }
        catch (err) {
        }
        
    }
    return results;
}

SIMain.clearObjectCache = function(theObj) {
    SIMain.objectMap[theObj] = null;
}

SIMain.styleCache = new Object();
SIMain.findStyle = function(name) {
    if (SIMain.styleCache[name])
        return SIMain.styleCache[name];
    var styles = document.styleSheets[0].rules;
    for (var i = 0; i < styles.length; i++) {
        if (styles[i].selectorText == name) {
            SIMain.styleCache[name] = styles[i].style;
            return styles[i].style;   
        }   
    }   
}

SIMain.setUpLinks = function() {
    
    var elem = document.getElementById('glossary');
    elem.innerHTML = SIConfig.labGlossary;
    var elem = document.getElementById('copy');
    elem.innerHTML = SIConfig.labCopyThis;
    var elem = document.getElementById('helpBox');
    elem.innerHTML = SIConfig.hepLink;
    
    SIMain.makeLink('glossary', SIMain.showGlossary);
    SIMain.makeLink('copy', SIMain.copySummary);
    SIMain.makeLink('moreHelp', SIMain.openHelpDialog).tabIndex = 5;;
    SIMain.makeLink('checkup', SIMain.openCU).tabIndex = 5;;
    SIMain.makeLink('antispy', SIMain.openAS).tabIndex = 5;;
}

SIMain.linkCallback = new Object();
SIMain.makeLink = function(id, callBack, theFrame) {
    if (theFrame) {
        var aTag = SIMain.getFrameElement(theFrame,id);
    }
    else {
        var aTag = document.getElementById(id);
    }
    if (aTag) {
        aTag.target = '_self';
        aTag.href = 'javascript:void';
        aTag.onkeypress = SIMain.handleLink; 
        aTag.onclick = SIMain.handleLink;
        SIMain.linkCallback[id] = callBack;

        var linkStyle = SIMain.findStyle('.link');
        if (linkStyle) {
            aTag.style.cssText += linkStyle.cssText;
        }
    }
    return aTag;
}

SIMain.cloneStr = function(str) {
    var newStr = "";
    for (var i = 0; i < str.length; i++) {
        newStr +=  str.charAt(i);   
    }
    return newStr;
}

SIMain.handleLink = function() {
    var newId = SIMain.cloneStr(this.id);
    var infoIndex = (this.infoIndex) ? SIMain.cloneStr(this.infoIndex) : null;
    var infoType = (this.infoType) ? SIMain.cloneStr(this.infoType) : null;
    var infoFrame = (this.infoFrame) ? SIMain.cloneStr(this.infoFrame) : null;
    var theEvent = event;
    /*
    if (infoFrame) {
        theEvent = frames[infoFrame].event;
    }
    */
    
    if (theEvent.keyCode == 13 || theEvent.type == 'click') {
        if (infoIndex) {
            SIMain.showInfo(infoIndex, infoType);            
        }
        else {
            if ( SIMain.linkCallback[newId] ) {
                SIMain.linkCallback[newId]();
            }
        }
    }
    return false;
}

SIMain.value = function(value) {
    var result = SIConfig.valueMap[value.toLowerCase()];
    return (result) ? result : value;
}

SIMain.cursorWaitTimer = null;
SIMain.cursorWaitOn = function() {
    window.external.ScriptHelper.SetCursor(1);
}

SIMain.cursorWait = function(on) {
    if (on) {
        window.external.ScriptHelper.SetCursor(1);
        if (SIMain.cursorWaitTimer == null) {
            SIMain.cursorWaitTimer = setInterval('SIMain.cursorWaitOn()',5);
        }
    }
    else {
        if (SIMain.cursorWaitTimer) {
            clearInterval(SIMain.cursorWaitTimer);
            SIMain.cursorWaitTimer = null;
        }
        window.external.ScriptHelper.SetCursor(0);
    }
    return;
}

/*
SIMain.frameReady = function(frameId) {
    var theFrame = frames[frameId].frameElement;
    if ( !(frameId == 'connect' || frameId == 'summary'))  {
        if (SIMain[frameId]) {
            if ( !theFrame.inited ) {
                theFrame.inited = true;
                setTimeout("SIMain." + frameId + "()", theFrame.siTabInd*25);
            }
        }
    }
}
*/

SIMain.frameReadyList = ['sysinf','aol','util'];
SIMain.callReadyFrames = function() {
    SIPaneTab.setTab( SIPaneTab.startupDefault );

    for (var i = 0; i < SIMain.frameReadyList.length; i++) {
        setTimeout("SIMain." + SIMain.frameReadyList[i] + "()", 10*i);
    }
}          


SIMain.closeAcion = function() {
    window.external.ScriptHelper.CloseMainWindow();
}
SIMain.minAcion = function() {
    window.external.ScriptHelper.MinWindow();
}

SIMain.moveWindow = function(top, left) {
    window.external.ScriptHelper.MoveWindow(left, top);
}

SIMain.waitForFrameLoad = function() {
}

SIMain.getFrameElement = function(frameID, id) {
    return document.getElementById(id);           
}


SIMain.disableKeys = function() {
    return false;
}

SIMain.showProgressDlg = function(message) {
    var elem = document.getElementById('shield');
    elem.style.visibility = 'visible';
    var elem = document.getElementById('progDlg');
    elem.style.visibility = 'visible';
    var elem = document.getElementById('progText');
    elem.innerHTML = message;
    document.body.onkeydown = SIMain.disableKeys;
    document.body.onkeyup = SIMain.disableKeys;
    document.body.onkeypress = SIMain.disableKeys;
    document.body.onkeyup = SIMain.disableKeys;
    //document.body.focus();
    SIButton.map['closebox'].disable();
    
}

SIMain.hideProgressDlg = function() {
    var elem = document.getElementById('shield');
    elem.style.visibility = 'hidden';
    var elem = document.getElementById('progDlg');
    elem.style.visibility = 'hidden';
    document.body.onkeydown = null;
    document.body.onkeyup = null;
    document.body.onkeypress = null;
    SIButton.map['closebox'].enable();
}

// System Info Tab
SIMain.driveList = null;
SIMain.sysinf = function() {
    var theFrame = 'sysinf';
    if (SIMain.frameInited[theFrame]) return;
    SIMain.frameInited[theFrame] = true;
    var objSysHardware = SIMain.getObject('objSysHardware');
    var objSysSoftware = SIMain.getObject('objSysSoftware');
    var objAOLSoftware = SIMain.getObject('objAOLSoftware');
    var objMinReq = SIMain.getObject('objMinReq');
    var lastLaunchedAppPath = objAOLSoftware.lastLaunchedAppPath;


    var elem = SIMain.getFrameElement(theFrame,'labProcessor');
    elem.innerHTML = SIConfig.labProcessor;
    var elem = SIMain.getFrameElement(theFrame,'labMemory');
    elem.innerHTML = SIConfig.labMemory;
    var elem = SIMain.getFrameElement(theFrame,'labVideo');
    elem.innerHTML = SIConfig.labVideo;
    var elem = SIMain.getFrameElement(theFrame,'labMultimedia');
    elem.innerHTML = SIConfig.labMultimedia;
    var elem = SIMain.getFrameElement(theFrame,'labPageFile');
    elem.innerHTML = SIConfig.labPageFile;
    var elem = SIMain.getFrameElement(theFrame,'labWindows');
    elem.innerHTML = SIConfig.labWindows;
    var elem = SIMain.getFrameElement(theFrame,'labBrowser');
    elem.innerHTML = SIConfig.labBrowser;
    var elem = SIMain.getFrameElement(theFrame,'labFirewall');
    elem.innerHTML = SIConfig.labFirewall;
    var elem = SIMain.getFrameElement(theFrame,'labAnti');
    elem.innerHTML = SIConfig.labAnti;
    var elem = SIMain.getFrameElement(theFrame,'labPlug');
    elem.innerHTML = SIConfig.labPlug;
    var elem = SIMain.getFrameElement(theFrame,'labNote');
    elem.innerHTML = SIConfig.labNote;


    var elem = SIMain.getFrameElement(theFrame,'cpuVer');
    elem.innerHTML  = objSysHardware.processorMakeAndModel + ' ' + objSysHardware.processorSpeed + ' ' + SIMain.value('mhz');

    var elem = SIMain.getFrameElement(theFrame,'memVer');
    elem.innerHTML  = objSysHardware.numMemoryMB + ' '+SIMain.value('mb')+'  '+SIMain.value('total')+' (' + objSysHardware.memoryPercentLoad + SIMain.value('percent') + ' ' + SIMain.value('load') + ')';
    var isMemory = objMinReq.memory( lastLaunchedAppPath );
    if ( ! isMemory ) {
        elem.style.color = SIConfig.notMeetMinReqColor;
    }



    var elem = SIMain.getFrameElement(theFrame,'vidVer');
    var vRes = objSysHardware.videoResolution;
    var vDepth = objSysHardware.videoColorDepth;
    elem.innerHTML  = vRes + ' ' + vDepth;
    
    var isRes = objMinReq.videoResolution( lastLaunchedAppPath );
    var isDepth = objMinReq.videoColorDepth( lastLaunchedAppPath );
    if ( ! ( isRes || isDepth )) {
        elem.style.color = SIConfig.notMeetMinReqColor;
    }

    var elem = SIMain.getFrameElement(theFrame,'mmVer');
    elem.innerHTML  = objSysHardware.multimediaInfo;
    
    var elem = SIMain.getFrameElement(theFrame,'pageFile');
    elem.innerHTML  = objSysHardware.pageFilePercentFree + SIMain.value('percent') + ' ' + SIMain.value('free');

    var elem = SIMain.getFrameElement(theFrame,'winVer');
    elem.innerHTML  = objSysSoftware.operatingSysVersion;

    var elem = SIMain.getFrameElement(theFrame,'brwVer');
    elem.innerHTML  = objSysSoftware.ieBrowserVersion;

    
    var html = '';
    var eeArrayPlugin = objSysSoftware.getPluginInfoList();
    for (var m = 0; m < eeArrayPlugin.count; m++) {
        var pluginListVar = eeArrayPlugin.getValue(m);
        html += pluginListVar.name + ', ' + pluginListVar.version + '<br>';
    }
    var elem = SIMain.getFrameElement(theFrame,'plugins');
    elem.innerHTML = (html == '') ? SIConfig.noPlugin : html;

    var html = '';
    var antiVirusList = objSysSoftware.getAntivirusList();
    for (var m = 0; m < antiVirusList.count; m++) {
        var av = antiVirusList.getValue(m);
        html += av + '<br>';
    }
    var elem = SIMain.getFrameElement(theFrame,'antivirus');
    elem.innerHTML = (html == '') ? SIConfig.noAntiVirus : html;   
    
    var elem = SIMain.getFrameElement(theFrame,'firewall');
    elem.innerHTML = SIMain.firwwall();
    
    
    // Disk Drive table
    
    var drvArray = (SIMain.driveList == null) ? SIMain.driveList = objSysHardware.getDriveInfoList() : SIMain.driveList;
    var iNumDrives = drvArray.count;
      
    var elem = SIMain.getFrameElement(theFrame,'driveTemplate');
    var theComposer = HTMLComposer.create(elem.innerHTML, 'drivetable');
    var blockComposer = theComposer.getTokenBlock('driveRow');
    
    theComposer.replaceToken('labDiskDrive', SIConfig.labDiskDrive );
    theComposer.replaceToken('labFreeSpace', SIConfig.labFreeSpace );
    theComposer.replaceToken('labTotalSpace', SIConfig.labTotalSpace );

    for (var j = 0; j < iNumDrives; j++) {
        var disk = drvArray.getValue(j);

        var dDrive = disk.name + ' (' +  disk.letter + ':)';
        blockComposer.replaceToken('valDiskDrive', dDrive);
        
        var dFree = (disk.freeSpaceMB == '') ? '&nbsp;' : disk.freeSpaceMB + ' '+SIMain.value('mb')+' (' + parseInt(disk.freeSpaceMB / disk.totalSpaceMB * 100) + SIMain.value('percent')+' '+SIMain.value('free')+')';
        blockComposer.replaceToken('valFreeSpace', dFree);
        blockComposer.replaceToken('freeID', 'dDrive'+j);
              
        var dTotal = (disk.totalSpaceMB == '') ? '&nbsp;' : disk.totalSpaceMB + ' '+SIMain.value('mb')+'';;
        blockComposer.replaceToken('valTotalSpace', dTotal);
        
        blockComposer.next();
    }
    elem.innerHTML = theComposer.compose();
    elem.style.display = '';

    for (var j = 0; j < iNumDrives; j++) {
        var disk = drvArray.getValue(j);
        if ( !disk.removeable ) {
            if ( !(objMinReq.diskSpace( disk.freeSpaceMB, lastLaunchedAppPath)) ) {
                var elem = SIMain.getFrameElement(theFrame,'dDrive'+j);
                elem.style.color = SIConfig.notMeetMinReqColor;
            }
        }
    }  
}


SIMain.zeroFill = function(number) {
    return (number < 10)  ? '0' + number : number;
}

SIMain.firwwall = function(number) {
    var html = '';
    var objSysSoftware = SIMain.getObject('objSysSoftware');
   
    var listOfFirewalls = objSysSoftware.getFirewallList();
    for (var f = 0; f < listOfFirewalls.count; f++) {
        html += listOfFirewalls.getValue(f) + '<br>';
    }  
    return (html == '') ? SIConfig.noFirewall : html;
}


SIMain.formatDateTime = function(month, day, year, hour, minute) {
    var theDate = "";
    var d = new Date();
    if ( d.getDate() == day && (d.getMonth()+1) == month && year == d.getFullYear() ) {
        theDate = SIMain.value('today');
    }
    else {
        theDate = SIMain.zeroFill(month) + '/' + SIMain.zeroFill(day) + '/' + year;
    }

    var theTime = 0;
    var ampm = '';
    
    if (hour > 12) {
        theTime = hour - 12;    
        ampm = 'pm';
    }
    else if (hour == 12)  {
        theTime = hour;    
        ampm = 'pm';
    }
    else if (hour == 0)  {
        theTime = 12;    
        ampm = 'am';
    }
    else {
        theTime = hour;    
        ampm = 'am';
    }

    theTime += ':'  + SIMain.zeroFill(minute) + ' ' + ampm;
    return theDate + ', ' + theTime;
    
}

SIMain.formatIDX = function(size) {
    var m = parseInt(size/1000);
    var megs = size/100;
    megs = parseInt(megs) / 10;
    var remain = size - m * 1000;
    var k = (m > 1) ? m + ',' +  remain: size;
    var result = megs + ' '  + SIMain.value('mb') + ' (' + k + ' ' + SIMain.value('kb') + ')';
    return result;
}

// WAOL
SIMain.aol = function() {
    var theFrame = 'aol';
    if (SIMain.frameInited[theFrame]) return;
    SIMain.frameInited[theFrame] = true;
    var objAOLSoftware = SIMain.getObject('objAOLSoftware');
    var lastLaunchedAppPath = objAOLSoftware.lastLaunchedAppPath;
    var AppInfo = objAOLSoftware.getAppInfo(lastLaunchedAppPath);
  
  // labels
    var elem = SIMain.getFrameElement(theFrame,'aH1');
    elem.innerHTML = SIConfig.aH1;
    var elem = SIMain.getFrameElement(theFrame,'aH2');
    elem.innerHTML = SIConfig.aH2;
    var elem = SIMain.getFrameElement(theFrame,'aH3');
    elem.innerHTML = SIConfig.aH3;

    var elem = SIMain.getFrameElement(theFrame,'labLaunches');
    elem.innerHTML = SIConfig.labLaunches;
    var elem = SIMain.getFrameElement(theFrame,'labSuccessful');
    elem.innerHTML = SIConfig.labSuccessful;
    
    //var elem = SIMain.getFrameElement(theFrame,'labFaults');
    //elem.innerHTML = SIConfig.labFaults;
    //var elem = SIMain.getFrameElement(theFrame,'labDisconnects');
    //elem.innerHTML = SIConfig.labDisconnects;
    //var elem = SIMain.getFrameElement(theFrame,'labTray');
    //elem.innerHTML = SIConfig.labTray;
    //var elem = SIMain.getFrameElement(theFrame,'labRestarts');
    //elem.innerHTML = SIConfig.labRestarts;

    var elem = SIMain.getFrameElement(theFrame,'labLast');
    elem.innerHTML = SIConfig.labLast;
    var elem = SIMain.getFrameElement(theFrame,'labIDX');
    elem.innerHTML = SIConfig.labIDX;
    var elem = SIMain.getFrameElement(theFrame,'labApplication');
    elem.innerHTML = SIConfig.labApplication;
    var elem = SIMain.getFrameElement(theFrame,'labData');
    elem.innerHTML = SIConfig.labData;
    var elem = SIMain.getFrameElement(theFrame,'labMessages');
    elem.innerHTML = SIConfig.labMessages;
    var elem = SIMain.getFrameElement(theFrame,'labUpdates');
    elem.innerHTML = SIConfig.labUpdates;
    var elem = SIMain.getFrameElement(theFrame,'labSearch');
    elem.innerHTML = SIConfig.labSearch;
    var elem = SIMain.getFrameElement(theFrame,'labSearching');
    elem.innerHTML = SIConfig.labSearching;
    var elem = SIMain.getFrameElement(theFrame,'labOther');
    elem.innerHTML = SIConfig.labOther;
    var elem = SIMain.getFrameElement(theFrame,'labLast1');
    elem.innerHTML = SIConfig.labLast;
    var elem = SIMain.getFrameElement(theFrame,'labIDX1');
    elem.innerHTML = SIConfig.labIDX;
    var elem = SIMain.getFrameElement(theFrame,'labApplication1');
    elem.innerHTML = SIConfig.labApplication;
    var elem = SIMain.getFrameElement(theFrame,'labData1');
    elem.innerHTML = SIConfig.labData;
    var elem = SIMain.getFrameElement(theFrame,'labMessages1');
    elem.innerHTML = SIConfig.labMessages;
    var elem = SIMain.getFrameElement(theFrame,'labUpdates1');
    elem.innerHTML = SIConfig.labUpdates;

    // values  AppInfo.mainIDXSizeKB
    var elem = SIMain.getFrameElement(theFrame,'lastUsed');
    elem.innerHTML  = SIMain.formatDateTime(AppInfo.lastUsedOnMonth, AppInfo.lastUsedOnDay, AppInfo.lastUsedOnYear, AppInfo.lastUsedOnHour, AppInfo.lastUsedOnMinute) + ' (' + SIConfig.labInstalledOn + " " +  AppInfo.installDate + ')';
    var elem = SIMain.getFrameElement(theFrame,'numLaunches');
    elem.innerHTML  = AppInfo.numLaunches;
    var elem = SIMain.getFrameElement(theFrame,'idx');
    elem.innerHTML  = SIMain.formatIDX(AppInfo.mainIDXSizeKB);
    var elem = SIMain.getFrameElement(theFrame,'numLogins');
    elem.innerHTML  = AppInfo.numLogins;
    //var elem = SIMain.getFrameElement(theFrame,'numTrayLaunches');
    //elem.innerHTML  = AppInfo.numTrayLaunches;
    //var elem = SIMain.getFrameElement(theFrame,'percentAbnormDisc');
    //elem.innerHTML  = (AppInfo.percentAbnormDisc == 'formatting bug') ? SIMain.value('error') : AppInfo.percentAbnormDisc ;
    //var elem = SIMain.getFrameElement(theFrame,'percentFaults');
    //elem.innerHTML  = (AppInfo.percentFaults == 'formatting bug') ? SIMain.value('error') : AppInfo.percentFaults ;
    //var elem = SIMain.getFrameElement(theFrame,'percentAbnormRestarts');
    //elem.innerHTML  = (AppInfo.percentAbnormRestarts == 'formatting bug') ? SIMain.value('error') : AppInfo.percentAbnormRestarts ;
    
    var elem = SIMain.getFrameElement(theFrame,'versionNumber');
    elem.innerHTML  = AppInfo.appName + ', ' + AppInfo.versionNumber;
    var elem = SIMain.getFrameElement(theFrame,'appFolderPath');
    elem.innerHTML  = AppInfo.appFolderPath
    var elem = SIMain.getFrameElement(theFrame,'dataFolderPath');
    elem.innerHTML  = AppInfo.dataFolderPath;

    var dataPathOfLastLaunchedApp = AppInfo.dataFolderPath;
    var eeArrayOfErrors = objAOLSoftware.getErrorInfoList(dataPathOfLastLaunchedApp);
    var iNumErrors = eeArrayOfErrors.count;
    var elem = SIMain.getFrameElement(theFrame,'messages');
    
    var messages = new Array();
    for (var i = 0; i < iNumErrors; ++i) {
        var error = eeArrayOfErrors.getValue(i);
        var line = error.date + ' ' + error.description + '<br>';
        messages[i] = line;
        if (i < SIMain.maxMesssages) {
            elem.innerHTML += line;
        }
    }
    elem.innerHTML += SIMain.addInfo(messages, SIConfig.viewMessages, 'messages', theFrame);

    var eeArrayOfUpdates = objAOLSoftware.getUpdateInfoList(dataPathOfLastLaunchedApp);
    var iNumUpdates = eeArrayOfUpdates.count;
    var elem = SIMain.getFrameElement(theFrame,'updates');
     
    var messages = new Array();
    for (var u = 0; u < iNumUpdates; ++u) {   
        var updateInf = eeArrayOfUpdates.getValue(u);
        var line = updateInf.date + ' ' + updateInf.description  + ' ' +  updateInf.status + '<br>';
        messages[u] = line;
        if (u < SIMain.maxUpdates) {
            elem.innerHTML += line;
        }
    }
    elem.innerHTML += SIMain.addInfo(messages, SIConfig.viewUpdates, 'updates', theFrame);
    
    setTimeout('SIMain.showAOL()',1);

}
SIMain.showAOL = function() {
    var theFrame = 'aol';
    var elem = SIMain.getFrameElement(theFrame,'aolcontent');
    elem.style.display = '';
}


SIMain.addInfo = function(messages, label, type, frame) {
    var result = SIMain.value('none');
    if (messages.length == 0) return result;
    var infoDataIndex = SIMain.infoData.length;
    result = '<a id=infoIndex' + infoDataIndex + ' infoIndex=' + infoDataIndex + ' infoType=' + type + ' infoFrame=' + frame +'>' + label +'</a><br>';
    SIMain.infoData[infoDataIndex] = messages;
    setTimeout('SIMain.makeLink("infoIndex' + infoDataIndex + '", null, "'+frame+'")',200);
    return result;
}

function searchObject() {
    function ScanCallBackFunction() {
        var objAOLSoftware = SIMain.getObject('objAOLSoftware');
        if (SIMain.canceled) {
            SIButton.map['search'].enable();
            return;
        }
        
        var theFrame = 'aol';
        var elem = SIMain.getFrameElement(theFrame,'search2');
        elem.style.display = 'none';
        
        var search3 = SIMain.getFrameElement(theFrame,'search3');
        
        var pathArray = objAOLSoftware.getInstallationPathsList();
        var iNumPaths = pathArray.count;
        var path = "";   
        var AppInfo = null;
        
        var theComposer = HTMLComposer.create(search3.innerHTML, 'aolversions');
        var blockComposer = theComposer.getTokenBlock('AOLBlock');
        var numBlocksReplaced = 0;
        for (var j = 0; j < iNumPaths; ++j) {
            path = pathArray.getValue(j);
            AppInfo = objAOLSoftware.getAppInfo(path);
            if (objAOLSoftware.lastLaunchedAppPath != AppInfo.appFolderPath) {
                numBlocksReplaced++;
                blockComposer.replaceToken('versionNumber', AppInfo.appName + ', ' + AppInfo.versionNumber);

                var lastUsed = SIMain.formatDateTime(AppInfo.lastUsedOnMonth, AppInfo.lastUsedOnDay, AppInfo.lastUsedOnYear, AppInfo.lastUsedOnHour, AppInfo.lastUsedOnMinute ) + ' (' + SIConfig.labInstalledOn + " " +  AppInfo.installDate + ')';
                blockComposer.replaceToken('lastUsed', lastUsed);
                blockComposer.replaceToken('idx', SIMain.formatIDX(AppInfo.mainIDXSizeKB));
                blockComposer.replaceToken('appFolderPath', AppInfo.appFolderPath);
                blockComposer.replaceToken('dataFolderPath', AppInfo.dataFolderPath);

                var dataPathOfLastLaunchedApp = AppInfo.dataFolderPath;
                var eeArrayOfErrors = objAOLSoftware.getErrorInfoList(dataPathOfLastLaunchedApp);
                var iNumErrors = eeArrayOfErrors.count;
                var html = "";
                var messages = new Array();
                for (var i = 0; i < iNumErrors; ++i) {
                    var error = eeArrayOfErrors.getValue(i);
                    var line = error.date + ' ' + error.description + '<br>';
                    messages[i] = line;
                    if (i < SIMain.maxMesssages) {
                        html += line;
                    }
                }
                html += SIMain.addInfo(messages, SIConfig.viewMessages, 'messages', theFrame);
                blockComposer.replaceToken('messages', html);

                var eeArrayOfUpdates = objAOLSoftware.getUpdateInfoList(dataPathOfLastLaunchedApp);
                var iNumUpdates = eeArrayOfUpdates.count;
                var html = "";
                var messages = new Array();
                for (var u = 0; u < iNumUpdates; ++u) {   
                    var updateInf = eeArrayOfUpdates.getValue(u);
                    var line = updateInf.date + ' ' + updateInf.description  + ' ' +  updateInf.status + '<br>';
                    messages[u] = line;
                    if (u < SIMain.maxUpdates) {
                        html += line;
                    }
                }
                html += SIMain.addInfo(messages, SIConfig.viewUpdates, 'updates', theFrame);

                blockComposer.replaceToken('updates', html);
                blockComposer.next(); 
            }
        }
            
        if (numBlocksReplaced == 0) {
            theComposer.replaceTokenBlock('AOLBlock', null);
            search3.innerHTML = theComposer.compose();
            var elem = SIMain.getFrameElement(theFrame,'labOther');
            elem.innerHTML = SIConfig.labNoOther;
        }
        else {
            search3.innerHTML = theComposer.compose();
            var elem = SIMain.getFrameElement(theFrame,'labOther');
            elem.innerHTML = SIConfig.labOther;
        }
        search3.style.display = '';
        var elem = SIMain.getFrameElement(theFrame,'aol');
        elem.scrollTop = 9999;            

    }

    this.ScanDone = ScanCallBackFunction;
}

SIMain.canceled = false;
SIMain.startSearch = function() {
    if( objSvc ) {
        var objAOLSoftware = SIMain.getObject('objAOLSoftware');
        if( objAOLSoftware ) {
            var theFrame = 'aol';
            var elem = SIMain.getFrameElement(theFrame,'search1');
            elem.style.display = 'none';
            var elem = SIMain.getFrameElement(theFrame,'search2');
            elem.style.display = '';
            var elem = SIMain.getFrameElement(theFrame,'aol');
            elem.scrollTop = 9999;            
            var lastLaunchedAppPath = objAOLSoftware.lastLaunchedAppPath;
            var obj = new searchObject();
            SIMain.canceled = false;

            objAOLSoftware.startScanForInstallationPaths(obj);
        }   
    }
}

SIMain.cancelSearch = function() {
    if( objSvc ) {
        var objAOLSoftware = SIMain.getObject('objAOLSoftware');
        if( objAOLSoftware ) {
            var theFrame = 'aol';
            var elem = SIMain.getFrameElement(theFrame,'search1');
            elem.style.display = '';
            var elem = SIMain.getFrameElement(theFrame,'search2');
            elem.style.display = 'none';
            var elem = SIMain.getFrameElement(theFrame,'search3');
            elem.style.display = 'none';
            SIMain.canceled = true;
            SIButton.map['search'].disable();
            objAOLSoftware.cancelTheScan();
        }   
    }
}

// Utils
SIMain.util = function() {
    var theFrame = 'util';   
    if (SIMain.frameInited[theFrame]) return;
    SIMain.frameInited[theFrame] = true;
    var objSysHardware = SIMain.getObject('objSysHardware');
    var objAOLSoftware = SIMain.getObject('objAOLSoftware');
    var objSysSoftware = SIMain.getObject('objSysSoftware');

    var elem = SIMain.getFrameElement(theFrame,'uH1');
    elem.innerHTML = SIConfig.uH1;
    var elem = SIMain.getFrameElement(theFrame,'uH2');
    elem.innerHTML = SIConfig.uH2;
    var elem = SIMain.getFrameElement(theFrame,'uH3');
    elem.innerHTML = SIConfig.uH3;
    var elem = SIMain.getFrameElement(theFrame,'uH4');
    elem.innerHTML = SIConfig.uH4;
    var elem = SIMain.getFrameElement(theFrame,'uH5');
    elem.innerHTML = SIConfig.uH5;
    
    var elem = SIMain.getFrameElement(theFrame,'labAdapter');
    elem.innerHTML = SIConfig.labAdapter;
    var elem = SIMain.getFrameElement(theFrame,'labCurrent');
    elem.innerHTML = SIConfig.labCurrent;
    var elem = SIMain.getFrameElement(theFrame,'labMaximum');
    elem.innerHTML = SIConfig.labMaximum;
    var elem = SIMain.getFrameElement(theFrame,'labInternet');
    elem.innerHTML = SIConfig.labInternet;
    var elem = SIMain.getFrameElement(theFrame,'labTask');
    elem.innerHTML = SIConfig.labTask;
    var elem = SIMain.getFrameElement(theFrame,'labAdd');
    elem.innerHTML = SIConfig.labAdd;
    var elem = SIMain.getFrameElement(theFrame,'labDevice');
    elem.innerHTML = SIConfig.labDevice;
    var elem = SIMain.getFrameElement(theFrame,'labServices');
    elem.innerHTML = SIConfig.labServices;
    var elem = SIMain.getFrameElement(theFrame,'labColor');
    elem.innerHTML = SIConfig.labColor;
    var elem = SIMain.getFrameElement(theFrame,'labNetwork');
    elem.innerHTML = SIConfig.labNetwork;
    var elem = SIMain.getFrameElement(theFrame,'labWebUtil');
    elem.innerHTML = SIConfig.labWebUtil;
    var elem = SIMain.getFrameElement(theFrame,'labRelease');
    elem.innerHTML = SIConfig.labRelease;
    var elem = SIMain.getFrameElement(theFrame,'labPing');
    elem.innerHTML = SIConfig.labPing;
    var elem = SIMain.getFrameElement(theFrame,'labCheckup');
    elem.innerHTML = SIConfig.labCheckup;
    var elem = SIMain.getFrameElement(theFrame,'labCloseAOL');
    elem.innerHTML = SIConfig.labCloseAOL;


    var elem = SIMain.getFrameElement(theFrame,'currentCache');
    elem.innerHTML  = objSysSoftware.ieCurrentCacheSizeMB  + ' '+SIMain.value('mb');
    var elem = SIMain.getFrameElement(theFrame,'maxCache');
    elem.innerHTML  = objSysSoftware.ieMaximumCacheSizeMB + ' '+SIMain.value('mb');
 
    var elem = SIMain.getFrameElement(theFrame,'utilcontent');
    var theComposer = HTMLComposer.create(elem.innerHTML, 'defragdrive');
    var blockComposer = theComposer.getTokenBlock('DriveBlock');
    var driveList = (SIMain.driveList == null) ? SIMain.driveList = objSysHardware.getDriveInfoList() : SIMain.driveList;
    var defragB = new Array();
    for (var m = 0; m < driveList.count; m++) {
        var disk = driveList.getValue(m);
        if( !disk.removeable ) {
            blockComposer.replaceToken('driveToken', disk.letter + ':\\: '+ SIConfig.formatted + ' ' + disk.type );
            var buttonID = disk.letter+'drive'
            blockComposer.replaceToken('driveID', buttonID );
            defragB[defragB.length] = buttonID;
            blockComposer.next();
        }
    }
    var res = theComposer.compose();
    elem.innerHTML = res;
    
    for (var m = 0; m < defragB.length; m++) {
        SIButton.createClipped(defragB[m], SIMain.defrag);
    }

    elem.style.display = '';
    var elem = SIMain.getFrameElement(theFrame,'util');
    elem.style.display = '';

}

// Conectivity
SIMain.connect = function() {
    var theFrame = 'connect';
    if (SIMain.frameInited[theFrame]) return;
    SIMain.frameInited[theFrame] = true;
    SIMain.cursorWait(true);
    var elem = SIMain.getFrameElement(theFrame,theFrame+'labGetting');
    elem.innerHTML = SIConfig.labGetting;
    setTimeout("SIMain.connect15()",1);
}

SIMain.connectLabelSet = false;
SIMain.connect15 = function() {
    var theFrame = 'connect';
    SIMain.cursorWait(true);
  
    var objConnectivity = SIMain.getObject('objConnectivity');
    
    // Labels
    if (!SIMain.connectLabelSet) {
        var elem = SIMain.getFrameElement(theFrame,'cH1');
        elem.innerHTML = SIConfig.cH1;
        var elem = SIMain.getFrameElement(theFrame,'cH2');
        elem.innerHTML = SIConfig.cH2;
        var elem = SIMain.getFrameElement(theFrame,'cH3');
        elem.innerHTML = SIConfig.cH3;

        var elem = SIMain.getFrameElement(theFrame,'labNIC');
        elem.innerHTML = SIConfig.labNIC;
        var elem = SIMain.getFrameElement(theFrame,'labFirewall1');
        elem.innerHTML = SIConfig.labFirewall1;
        var elem = SIMain.getFrameElement(theFrame,'labACS');
        elem.innerHTML = SIConfig.labACS;
        var elem = SIMain.getFrameElement(theFrame,'labUSB');
        elem.innerHTML = SIConfig.labUSB;
        var elem = SIMain.getFrameElement(theFrame,'labOutside');
        elem.innerHTML = SIConfig.labOutside;
        var elem = SIMain.getFrameElement(theFrame,'labCall');
        elem.innerHTML = SIConfig.labCall;
        var elem = SIMain.getFrameElement(theFrame,'labTouch');
        elem.innerHTML = SIConfig.labTouch;
        var elem = SIMain.getFrameElement(theFrame,'labReconnect');
        elem.innerHTML = SIConfig.labReconnect;
        var elem = SIMain.getFrameElement(theFrame,'labDeviceName');
        elem.innerHTML = SIConfig.labDeviceName;
        var elem = SIMain.getFrameElement(theFrame,'labAttempts');
        elem.innerHTML = SIConfig.labAttempts;
        var elem = SIMain.getFrameElement(theFrame,'labDeviceName1');
        elem.innerHTML = SIConfig.labDeviceName;
        var elem = SIMain.getFrameElement(theFrame,'labAttempts1');
        elem.innerHTML = SIConfig.labAttempts;
        var elem = SIMain.getFrameElement(theFrame,'labSpeed');
        elem.innerHTML = SIConfig.labSpeed;
        var elem = SIMain.getFrameElement(theFrame,'labClient');
        elem.innerHTML = SIConfig.labClient;
        var elem = SIMain.getFrameElement(theFrame,'labNumber');
        elem.innerHTML = SIConfig.labNumber;
        var elem = SIMain.getFrameElement(theFrame,'labIP');
        elem.innerHTML = SIConfig.labIP;
        var elem = SIMain.getFrameElement(theFrame,'labDefault');
        elem.innerHTML = SIConfig.labDefault;
        var elem = SIMain.getFrameElement(theFrame,'labSubnet');
        elem.innerHTML = SIConfig.labSubnet;
        var elem = SIMain.getFrameElement(theFrame,'labMac');
        elem.innerHTML = SIConfig.labMac;
        var elem = SIMain.getFrameElement(theFrame,'labPort');
        elem.innerHTML = SIConfig.labPort;
        var elem = SIMain.getFrameElement(theFrame,'labHighest');
        elem.innerHTML = SIConfig.labHighest;
        var elem = SIMain.getFrameElement(theFrame,'labInterrupt');
        elem.innerHTML = SIConfig.labInterrupt;
        var elem = SIMain.getFrameElement(theFrame,'labAddress');
        elem.innerHTML = SIConfig.labAddress;
        var elem = SIMain.getFrameElement(theFrame,'labATI');
        elem.innerHTML = SIConfig.labATI;
        var elem = SIMain.getFrameElement(theFrame,'labConnAtt');
        elem.innerHTML = SIConfig.labConnAtt;
        SIMain.connectLabelSet = true;
    }
    // Values
    var elem = SIMain.getFrameElement(theFrame,'nicDetected');
    elem.innerHTML  = SIMain.value("detected" + objConnectivity.nicDetected);

    var elem = SIMain.getFrameElement(theFrame,'acsVersion');
    elem.innerHTML  = objConnectivity.acsVersion;

    var elem = SIMain.getFrameElement(theFrame,'firewall1');
    elem.innerHTML = SIMain.firwwall();

    var elem = SIMain.getFrameElement(theFrame,'usbDetected');
    elem.innerHTML = SIMain.value("detected" + objConnectivity.usbDetected);

    SIMain.showProgress(theFrame, 0);
    setTimeout("SIMain.connect1()",10);
}

SIMain.connect1 = function() {
    var theFrame = 'connect';
    SIMain.cursorWait(true);
    var objConnectivity = SIMain.getObject('objConnectivity');
    var elem = SIMain.getFrameElement(theFrame,'locTemplate');
    var theComposer = HTMLComposer.create(elem.innerHTML, 'locations');
    var locationBlock = theComposer.getTokenBlock('LocBlock');

    var locationsArray = objConnectivity.populateLocations();
    for (var m = 0; m < locationsArray.count; m++) {
        var theLocation = locationsArray.getValue(m);
        locationBlock.replaceToken('locationName', theLocation.locationName);
        locationBlock.replaceToken('locationTries',  theLocation.locationTries);

        var connectionBlock = theComposer.getTokenBlock('ConBlock');

        var foundModem = false;
        var connectionsArray = theLocation.getConnectionsForLocation();
        for (var a = 0; a < connectionsArray.count; a++) {
            var theConnection = connectionsArray.getValue(a);
            connectionBlock.replaceToken('connectionName',theConnection.connectionName);
            connectionBlock.replaceToken('connectionType', theConnection.connectionType);
            connectionBlock.replaceToken('connectionTries',  theConnection.connectionTries);
            connectionBlock.replaceToken('connectionDeviceName', theConnection.connectionDeviceName);

            if (theConnection.connectionType.toLowerCase() == 'tcp/ip connection') {
                connectionBlock.replaceTokenBlock('ModemBlock', null);
                connectionBlock.replaceToken('tcpipScript', theConnection.tcpipScript);
                //connectionBlock.replaceToken('tcpipTunnel', theConnection.tcpipTunnel);
                connectionBlock.replaceToken('tcpipRegularSetup', theConnection.tcpipRegularSetup);
                connectionBlock.replaceToken('tcpipHost', theConnection.tcpipHost);
                connectionBlock.replaceToken('tcpipPort', theConnection.tcpipPort);
                connectionBlock.replaceToken('tcpipUseProxy', theConnection.tcpipUseProxy);
                connectionBlock.replaceToken('tcpipProxyHost', theConnection.tcpipProxyHost);
                connectionBlock.replaceToken('tcpipProxyPort', theConnection.tcpipProxyPort);
                connectionBlock.replaceToken('tcpipProxyResolve', theConnection.tcpipProxyResolve);
                connectionBlock.replaceToken('tcpipProxyProtocol', theConnection.tcpipProxyProtocol);
            }
            else if (theConnection.connectionType.toLowerCase() == 'modem_connection') {
                connectionBlock.replaceTokenBlock('TCPBlock', null);
                connectionBlock.replaceToken('modemNumber', theConnection.modemNumber);
                connectionBlock.replaceToken('modemNetwork', theConnection.modemNetwork);
                connectionBlock.replaceToken('modemClientPPPReady', SIMain.value("ready"+theConnection.modemClientPPPReady));
                connectionBlock.replaceToken('modemNumberPPPReady', SIMain.value("ready"+theConnection.modemNumberPPPReady));
                connectionBlock.replaceToken('modemSpeed', theConnection.modemSpeed);

                if (!foundModem) {
                    locationBlock.replaceToken('modemTouchTone', SIMain.value('modem'+theConnection.modemTouchTone));
                    locationBlock.replaceToken('modemOutSideline', theConnection.modemOutSideline);
                    locationBlock.replaceToken('modemCallWaiting', SIMain.value('modem'+theConnection.modemCallWaiting));
                    locationBlock.replaceToken('modemAlwaysReconnect', SIMain.value('modem'+theConnection.modemAlwaysReconnect));
                    foundModem = true;
                }

            }
            else {
                connectionBlock.replaceTokenBlock('ModemBlock', null);
                connectionBlock.replaceTokenBlock('TCPBlock', null);
            }
            connectionBlock.next();
        }
        if (connectionsArray.count == 0) {
            locationBlock.replaceTokenBlock('ConBlock', null);
        }
        
        if (!foundModem) {
            locationBlock.replaceTokenBlock('ModemInfo', null);
        }        

        locationBlock.next();
    }
    if (locationsArray.count == 0) {
        theComposer.replaceTokenBlock('LocBlock', null);
    }
    elem.innerHTML = theComposer.compose();
    elem.style.display = '';
    SIMain.showProgress(theFrame, 1);
    setTimeout("SIMain.connect2()",10);
}

SIMain.connect2 = function() {
    var theFrame = 'connect';
    SIMain.cursorWait(true);
    var objConnectivity = SIMain.getObject('objConnectivity');


    var elem = SIMain.getFrameElement(theFrame,'netTemplate');
    var theComposer = HTMLComposer.create(elem.innerHTML, 'adapters');
    var blockComposer = theComposer.getTokenBlock('NetBlock');

    var adaptersArray = objConnectivity.adapters();
    for (var m = 0; m < adaptersArray.count; m++) {

        var theAdapter = adaptersArray.getValue(m);

        blockComposer.replaceToken('adapterName', theAdapter.adapterName);
        blockComposer.replaceToken('macAddress',  theAdapter.macAddress);
        blockComposer.replaceToken('ipAddress',   theAdapter.ipAddress);
        blockComposer.replaceToken('subNetMask', theAdapter.subNetMask);
        blockComposer.replaceToken('defaultGateway', theAdapter.defaultGateway);
        blockComposer.next();
    }
    elem.innerHTML = theComposer.compose();
    elem.style.display = '';
    
    SIMain.showProgress(theFrame, 2);
    setTimeout("SIMain.connect3()",10);
}

SIMain.connect3 = function() {
    var theFrame = 'connect';
    SIMain.cursorWait(true);
    var objConnectivity = SIMain.getObject('objConnectivity');

    
    var objModems = SIMain.getObject('objModems');
    if (objModems) {

        var elem = SIMain.getFrameElement(theFrame,'modemTemplate');
        var theComposer = HTMLComposer.create(elem.innerHTML, 'modems');
        if (SIMain.iModemUserOnline == 'UserOnline') {
            theComposer.replaceTokenBlock('ModemBlock', "<div class=label1 style='margin:10px;'>" + SIConfig.pleaseQuit + "</div>");
        }
        else {
            var blockComposer = theComposer.getTokenBlock('ModemBlock');
            var block1Composer = theComposer.getTokenBlock('ModemTable');

            var modemArray = objModems.getComPortInfoList();
            for (var m = 0; m < modemArray.count; m++) {
                var modem = modemArray.getValue(m);
                blockComposer.replaceToken('deviceName', modem.deviceName + ', ' + modem.comPort);
                if (modem.deviceName == 'Modem not installed.' ) {
                    blockComposer.replaceTokenBlock('ModemTable', null);
                }
                else {
                    blockComposer.replaceToken('comPort', modem.comPort);
                    blockComposer.replaceToken('interrupt', modem.interrupt);
                    blockComposer.replaceToken('address', modem.address);
                    blockComposer.replaceToken('highestSpeed', modem.highestSpeed);

                    var html = SIMain.addInfo({com:modem.comPort,device:modem.deviceName}, SIConfig.viewATI, 'ati', theFrame);
                    blockComposer.replaceToken('ati', html);
                }

                blockComposer.next();
            }
        }
        elem.innerHTML = theComposer.compose();
        elem.style.display = '';
    }
    SIMain.cursorWait(false);

    SIMain.showContent(theFrame);
}

SIMain.showContent = function(theFrame, load) {
    var elem = SIMain.getFrameElement(theFrame,theFrame+'loading');
    elem.style.display = (load) ? '' : 'none';
    var elem = SIMain.getFrameElement(theFrame,theFrame+'content');
    elem.style.display = (load) ? 'none' : '';
}

SIMain.showProgress = function(theFrame, item) {
    if (item < SIConfig.connectivityProgress.length) {
        var elem = SIMain.getFrameElement(theFrame,'what');
        elem.innerHTML  = SIConfig.connectivityProgress[item];
    }
}

// Summary
SIMain.summaryIndex = 0;
SIMain.summaryArray = new Array;
SIMain.summary = function() {
    var theFrame = 'summary';
    if (SIMain.frameInited[theFrame]) return;
    SIMain.frameInited[theFrame] = true;
    SIMain.cursorWait(true);
    var elem = SIMain.getFrameElement(theFrame,theFrame+'labGetting');
    elem.innerHTML = SIConfig.labGetting;

    for (var i in SIMain.objectMapper) {
        SIMain.summaryArray[SIMain.summaryArray.length] = i;
    }
    setTimeout('SIMain.waitSummary()',10);


}

SIMain.waitSummary = function() {
    var theFrame = 'summary';
    SIMain.cursorWait(true);

    var elem = SIMain.getFrameElement(theFrame,theFrame+'content');
    var obj = SIMain.summaryArray[SIMain.summaryIndex];

    try {
        var summaryList = SIMain.getObject(obj).getSummary();
        for (var j = (obj =='objSysSoftware') ? 1 : 0; j < summaryList.count; j++) {
            elem.innerHTML += summaryList.getValue(j) + '<br>';                     
        }
    }
    catch (err) {
    }
    SIMain.summaryIndex ++;
    if (SIMain.summaryIndex < SIMain.summaryArray.length) {
        if (obj == 'objAOLSoftware' ) {
            SIMain.showProgress(theFrame, 0);
        }
        if (obj == 'objConnectivity' ) {
            SIMain.showProgress(theFrame, 2);
        }

        setTimeout('SIMain.waitSummary()',10);
    }
    else {
        var elem = document.getElementById('copy');
        elem.style.visibility = 'visible';
        SIMain.cursorWait(false);
        SIMain.showContent(theFrame); 
    }
    
}

// Handlers callback
// App



SIMain.shutdownAOL = function(fromAction, actionHandler) {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        var result = objTools.getAOLRunningState();
        var doShutdown = false;
        action = "";
        if (fromAction == 'NoAction') {
            action = 'NoAction';
        }
        switch (result)  {
            case 0 :       // FAILURE
            break
            case 1 :       // DONT_PROMPT_JUST_SHUTDOWN
                doShutdown = true;
            break
            case 2 :       // PROMPT_RUNNING_BACKGROUND
                doShutdown = (SIMain.alert("cont", "cancel", "alertCloseAOLTitle", SIConfig["alertCloseAOLPrompt2"+action].replace(/@action@/,SIConfig.CloseAOLActions[fromAction]) ) == "1");
            break
            case 3 :       // PROMPT_RUNNING_FOREGROUND
                doShutdown = (SIMain.alert("cont", "cancel", "alertCloseAOLTitle", SIConfig["alertCloseAOLPrompt1"+action].replace(/@action@/,SIConfig.CloseAOLActions[fromAction]) ) == "1");
            break
            case 4 :       // PROMPT_RUNNING_BOTH
                doShutdown = (SIMain.alert("cont", "cancel", "alertCloseAOLTitle", SIConfig["alertCloseAOLPrompt3"+action].replace(/@action@/,SIConfig.CloseAOLActions[fromAction]) ) == "1");
            break
            case 5 :       // Not Running
                actionHandler();
            break
            
        }
        
        if (doShutdown) {
            var shutdownCallbackObject = new ShutdownCallbackObject(fromAction, actionHandler);
            SIMain.showProgressDlg(SIConfig.progCloseAOL);
            var result = objTools.shutdownAOL(shutdownCallbackObject);
        }
    }
}

function ShutdownCallbackObject(theFromAction, theActionHandler ) {
    var actionHandler = theActionHandler;
    var fromAction = theFromAction;

    this.ShutdownAOLDone = function CallBackFunction(s) {
        SIMain.hideProgressDlg();
        if (s == 'OK') {
            actionHandler();
            SIMain.frameInited['connect'] = false;
            SIMain.showContent('connect', true);
            SIMain.showProgress('connect', 0);
            SIMain.clearObjectCache('objModems');
        }
        else {
            SIMain.alert("ok1", null, "alertCloseAOLTitle",  SIConfig["alertCloseAOLError"+action].replace(/@action@/,SIConfig.CloseAOLActions[fromAction]));
        }
    }
}


SIMain.showGlossary = function() {
    var result = window.external.ScriptHelper.ShowHTMLDialog('ui/locale/html/dlg-info.htm',{dpiX:SIMain.dpiX, type:'glossary', title:SIConfig.dlgTitle['glossary'], frame:SIPaneTab.currentTab},
        "dialogHeight: 236px; dialogWidth: 323px; center: Yes; help: No; resizable: No; status: No;unadorned:Yes");
    var elem = document.getElementById('_close');
    SIWindow.focusButton(elem);
}

SIMain.alert = function(yesButton, noButton, titleID, content, noHelpLink) {
    var result = window.external.ScriptHelper.ShowHTMLDialog('ui/locale/html/dlg-alert.htm',{dpiX:SIMain.dpiX, yesAction:yesButton, noAction:noButton, title:titleID, data:content, addHelp:!noHelpLink},
        "dialogHeight: 236px; dialogWidth: 323px; center: Yes; help: No; resizable: No; status: No;unadorned:Yes");
    var elem = document.getElementById('_close');
    SIWindow.focusButton(elem);

    return result;
}

SIMain.showInfo = function(infoIndex, dType) {
    var theData = null; 
    if (dType == 'ati') {
        theData = SIMain.getATIArray(infoIndex);    
    }
    else {
        theData = SIMain.infoData[infoIndex];
    }
    if (theData) {
        var result = window.external.ScriptHelper.ShowHTMLDialog('ui/locale/html/dlg-info.htm',{dpiX:SIMain.dpiX, type:'info', title:SIConfig.dlgTitle[dType], data:theData},
            "dialogHeight: 236px; dialogWidth: 323px; center: Yes; help: No; resizable: No; status: No;unadorned:Yes");
    }
    else {
        SIMain.alert("ok1", null, "appName", '<br>' + SIConfig["IDS_MODEM_NOT_RESPOND"]);
    }
    var elem = document.getElementById('_close');
    SIWindow.focusButton(elem);
}

SIMain.getATIArray = function(infoIndex) {
    SIMain.cursorWait(true);
    var atiArray = new Array();
    params = SIMain.infoData[infoIndex];
    var objModems = SIMain.getObject('objModems');
    if (objModems) {
        try {
            var eeArrayATI = objModems.getMoreInfo(params.com, params.device);
        }
        catch (err) {
            SIMain.cursorWait(false);
            return null;            
        }

        var iNumATI = eeArrayATI.count;
        for (var a = 0; a < iNumATI; a++){
            var value = eeArrayATI.getValue(a);
            atiArray[a] = value.commandName + ": " + value.resultText ;
        }
    }
    SIMain.cursorWait(false);
    return atiArray;
}

// Handlers callback
// Main Page
SIMain.openHelpDialog = function() {
    SIMain.alert("close", null, "alertHelpTitle", SIConfig["alertNeedHelp"], true)
}
// AOL

SIMain.openAppFolder = function() {
    var objAOLSoftware = SIMain.getObject('objAOLSoftware');
    if( objAOLSoftware ) {
        SIMain.cursorWait(true);
        var lastLaunchedAppPath = objAOLSoftware.lastLaunchedAppPath;
        var AppInfo = objAOLSoftware.getAppInfo(lastLaunchedAppPath);
        window.external.ScriptHelper.InvokeExplorer(AppInfo.appFolderPath);
        SIMain.cursorWait(false);
    }
}

SIMain.openDataFolder = function() {
    var objAOLSoftware = SIMain.getObject('objAOLSoftware');
    if( objAOLSoftware ) {
        SIMain.cursorWait(true);
        var lastLaunchedAppPath = objAOLSoftware.lastLaunchedAppPath;
        var AppInfo = objAOLSoftware.getAppInfo(lastLaunchedAppPath);
        window.external.ScriptHelper.InvokeExplorer(AppInfo.dataFolderPath);
        SIMain.cursorWait(false);

    }
}

SIMain.showQuick = function() {
    var objAOLSoftware = SIMain.getObject('objAOLSoftware');
    var lastLaunchedAppPath = objAOLSoftware.lastLaunchedAppPath;
    var AppInfo = objAOLSoftware.getAppInfo(lastLaunchedAppPath);

    var objTools = SIMain.getObject('objTools');
    if (SIMain.alert("ok", "cancel", "alertQuickTitle", SIConfig["alertQuickWarn"].replace(/@name@/,AppInfo.appName) ) == "1") {
        SIMain.shutdownAOL('quick', SIMain.showQuick1);
    }
}

SIMain.showQuick1 = function() {
    var objAOLSoftware = SIMain.getObject('objAOLSoftware');
    var lastLaunchedAppPath = objAOLSoftware.lastLaunchedAppPath;
    var AppInfo = objAOLSoftware.getAppInfo(lastLaunchedAppPath);

    var objTools = SIMain.getObject('objTools');
    var objCB = new QuickCallbackObject(); 
    SIMain.showProgressDlg(SIConfig.progQuick.replace(/@name@/,AppInfo.appName));
    var status = objTools.launchQuickRestore(lastLaunchedAppPath, objCB);
}

function QuickCallbackObject() {
    // the C++ service calls this back when it is done with quick restore
    function QRDone_CallBackFunct( objStatus ) {
        SIMain.hideProgressDlg();
        if( objStatus.success ) {
            if( objStatus.needReboot ) {
                SIMain.alert("close", null, "alertQuickTitle", '<br>' + SIConfig["alertQuickReboot"]);
            }
            else {
                SIMain.alert("close", null, "alertQuickTitle", '<br>' + SIConfig["alertQuickDone"]);        
            }

        }
        else {
            var msg = SIConfig[objStatus.errorMessageName];
            if (!msg) {
                msg = objStatus.errorMessage;
            }
            msg += ' ' + objStatus.additionalErrorText;
            SIMain.alert("close", null, "alertQuickTitle", '<br>' + msg);
        }
    }
    this.QuickRestoreDone = QRDone_CallBackFunct;
}



// Handlers callback
// Connect

function addLocationCallbackObject() {
    this.AddLocationDone = function CallBackFunction(s) {
        SIMain.hideProgressDlg();
        if (s == 'SUCCESS') {
            SIMain.showContent('connect', true);
            SIMain.showProgress('connect', 0);
            SIMain.clearObjectCache('objModems');

            setTimeout('SIMain.connect()',5);
        }
    }
}

SIMain.createdialup = function() {
    var objConnectivity = SIMain.getObject('objConnectivity');
    var objCB = new addLocationCallbackObject(); 
    objConnectivity.addLocation(objCB);
    SIMain.showProgressDlg(SIConfig.progAddLocation);
}

SIMain.resetLoc = function() {
    if (SIMain.alert("yesreset", "cancel", "alertResetTitle", SIConfig["alertResetWarn"]) == "1") {
        SIMain.shutdownAOL('reset',SIMain.resetLoc1);        
    }
}

SIMain.resetLoc1 = function() {        
    var objConnectivity = SIMain.getObject('objConnectivity');
    try {
        var objCB = new ResetCallbackObject(); 
        var reset = objConnectivity.resetLocations(objCB);
    }
    catch (err) {
         SIMain.alert("ok1", null, "alertResetTitle", '<br>' + SIConfig["alertResetFail"]);
         return;
    }
    if (reset == "UserOnline") {
        SIMain.alert("ok1", null, "alertResetTitle", '<br>' + SIConfig["alertResetFail0"]);
    }
    else {
        SIMain.showProgressDlg(SIConfig.progReset);
    }
}

function ResetCallbackObject() {
    // the C++ service calls this back when it is done with quick restore
    function Reset_CallBackFunct( s ) {
        SIMain.hideProgressDlg();
 
        if( s == "SUCCESS" ) {
            SIMain.alert("ok1", null, "alertResetTitle", '<br>' + SIConfig["alertResetConfirm"]);
            SIMain.showContent('connect', true);
            SIMain.showProgress('connect', 0);
            SIMain.clearObjectCache('objModems');

            setTimeout('SIMain.connect()',5);
        }
        else if( s == "FAILED" ) { 
            SIMain.alert("ok1", null, "alertResetTitle", '<br>' + SIConfig["alertResetFail"]);
        }       
        else if( s == "FAILED_TO_FIND_ACSINSTALL_REMOVEALLLOCALITIES" ) {
            SIMain.alert("ok1", null, "alertResetTitle", '<br>' + SIConfig["alertResetFail1"]);
        }
        else if( s == "FAILED_TO_LOAD_ACSINSTALLDLL" ) { 
            SIMain.alert("ok1", null, "alertResetTitle", '<br>' + SIConfig["alertResetFail2"]);
        }       
    }
    this.ResetLocationsDone = Reset_CallBackFunct;
}

// Handlers callback
// Utilities


                    ;
SIMain.defrag = function(letter) {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        objTools.launchDefragDrive(letter.substr(0,1))
        SIMain.cursorWait(false);
    }
}

SIMain.rebuild = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        var objAOLSoftware = SIMain.getObject('objAOLSoftware');
        if (objTools && objAOLSoftware) {
            if (SIMain.alert("ok", "cancel", "alertRebuildTitle", SIConfig["alertRebuildWarn"]) == "1") {
                SIMain.shutdownAOL('rebuild', SIMain.rebuild1);
            }
        }
    }
}

SIMain.rebuild1 = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        var objAOLSoftware = SIMain.getObject('objAOLSoftware');
        if (objTools && objAOLSoftware) {
                var lastLaunchedAppPath = objAOLSoftware.lastLaunchedAppPath;
                var objCB = new RebuildCallbackObject(); 
                SIMain.showProgressDlg(SIConfig.progRebuild);
                objTools.rebuildAOLAdapter(lastLaunchedAppPath, objCB);
        }
    }
}

function RebuildCallbackObject() {
    // the C++ service calls this back when it is done with quick restore
    function Rebuild_CallBackFunct( objStatus ) {
        SIMain.hideProgressDlg();
        if( objStatus.success ) {
            if( objStatus.needReboot ) {
                SIMain.alert("close", null, "alertRebuildTitle", '<br>' + SIConfig["alertRebuildReboot"]);
            }
            else {
                SIMain.alert("close", null, "alertRebuildTitle", '<br>' + SIConfig["alertRebuildDone"]);        
            }
        }
        else {
            var msg = SIConfig[objStatus.errorMessageName];
            if (!msg) {
                msg = objStatus.errorMessage;
            }
            msg += ' ' + objStatus.additionalErrorText;
            SIMain.alert("close", null, "alertRebuildTitle", '<br>' + msg);
        }
        
    }
    this.RebuildAOLAdapterDone = Rebuild_CallBackFunct;
}

SIMain.clearCache = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        objTools.clearIECache();
        var theFrame = 'util';   
        var objSysSoftware = SIMain.getObject('objSysSoftware');
        var elem = SIMain.getFrameElement(theFrame,'currentCache');
        elem.innerHTML  = objSysSoftware.ieCurrentCacheSizeMB  + ' '+SIMain.value('mb');
        var elem = SIMain.getFrameElement(theFrame,'maxCache');
        elem.innerHTML  = objSysSoftware.ieMaximumCacheSizeMB + ' '+SIMain.value('mb');
        SIMain.cursorWait(false);
    }
}

SIMain.openIOCP = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        objTools.launchInternetOptionsControlPanel();
        SIMain.cursorWait(false);
    }
}

SIMain.repairbrowser = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        objTools.launchAddRemovePrograms();
        SIMain.cursorWait(false);
    }
}

SIMain.openTM = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        var result = objTools.launchTaskManager();
        SIMain.cursorWait(false);
        if( result == "NA" ) { 
            SIMain.alert("ok1", null, "appName", '<br>' + SIConfig["IDS_NA"]);
        }       
   
    }
}

SIMain.openAR = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        objTools.launchAddRemovePrograms();
        SIMain.cursorWait(false);
    }
}

SIMain.openDM = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        objTools.launchDeviceControlPanel();
        SIMain.cursorWait(false);
    }
}

SIMain.openSM = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        var result = objTools.launchServicesManager();
        SIMain.cursorWait(false);
        if( result == "NA" ) { 
            SIMain.alert("ok1", null, "appName", '<br>' + SIConfig["IDS_NA"]);
        }       
        
    }
}

SIMain.openNC = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        objTools.launchNetworkControlPanel();
        SIMain.cursorWait(false);
    }
}

SIMain.openDP = function() {
    //Modified By Ved Bhatnagar to fix the Bug Number 78120
    SIMain.cursorWait(true);
    var result;
    var objAOLSoftware = SIMain.getObject('objAOLSoftware');
    var objTools = SIMain.getObject('objTools');
    if (objTools && objAOLSoftware){
        var colorValue;
        var colorString;
        var lastLaunchedAppPath = objAOLSoftware.lastLaunchedAppPath;
        var colorValue = objTools.getCurrentAOLColorMode(lastLaunchedAppPath);
        var colorMap = {"AUTO_DETECT":1,"256_COLORS":2,"MORE_THAN_256":3};
        var currentVal = colorMap[colorValue];
        SIMain.cursorWait(false);        
        result = window.external.ScriptHelper.ShowHTMLDialog('ui/locale/html/dlg-color.htm',{dpiX:SIMain.dpiX, title:SIConfig.alertColorTitle, ColorMode:SIConfig.alertColorMode, ColorMode1:SIConfig.alertColorMode1, ColorMode2:SIConfig.alertColorMode2, ColorMode3:SIConfig.alertColorMode3, currentVal:currentVal}, "dialogHeight: 236px; dialogWidth: 323px; center: Yes; help: No; resizable: No; status: No;unadorned:Yes");
        var elem = document.getElementById('_close');
        SIWindow.focusButton(elem);
    }
    SIMain.cursorWait(true);
    if (objTools && objAOLSoftware) {
        var lastLaunchedAppPath = objAOLSoftware.lastLaunchedAppPath;
        switch (result) {
            case  '1' :
                objTools.setAOLColorModeTo_AutoDetect( lastLaunchedAppPath );
            break;
            case  '2' :
                objTools.setAOLColorModeTo_256( lastLaunchedAppPath );
            break;
            case  '3' :
                objTools.setAOLColorModeTo_MoreThan256( lastLaunchedAppPath );
            break;
        }
    }
    SIMain.cursorWait(false);
}





SIMain.openWU = function() {
    SIMain.shutdownAOL('webutil', SIMain.openWU1);
}

SIMain.openWU1 = function() {
    var objTools = SIMain.getObject('objTools');

    SIMain.cursorWait(true);    
    objTools.launchWebUtils();
    SIMain.cursorWait(false);
}

SIMain.startRenew = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        objTools.releaseAndRenewIP();
        SIMain.cursorWait(false);
    }
}

SIMain.ping = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        objTools.launchCommandPrompt();
        SIMain.cursorWait(false);
    }
}

// Computer Checkup
SIMain.openCU = function() {
    var objAOLSoftware = SIMain.getObject('objAOLSoftware');
    var objTools = SIMain.getObject('objTools');
    if (objTools && objAOLSoftware) {
        var lastLaunchedAppPath = objAOLSoftware.lastLaunchedAppPath;
        SIMain.cursorWait(true);
        objTools.launchComputerCheckup(lastLaunchedAppPath);
        SIMain.cursorWait(false);
    }
}

SIMain.closeaol = function() {
    SIMain.shutdownAOL('NoAction', SIMain.closeaol1)
}

SIMain.closeaol1 = function() {
    SIMain.alert("ok1", null, "alertCloseAOLTitle", '<br>' + SIConfig["alertCloseAOLConfirmNoAction"]);
}


SIMain.openAS = function() {
    var objTools = SIMain.getObject('objTools');
    if (objTools) {
        SIMain.cursorWait(true);
        objTools.launchAOLAntiSpyware();
        SIMain.cursorWait(false);
    }
}

//  Summary
SIMain.copySummary = function() {
    var theFrame = 'summary';
    var elem = SIMain.getFrameElement(theFrame,theFrame+'content');
    SIMain.cursorWait(true);
    window.external.ScriptHelper.CopyToClipboard( elem.innerText);
    SIMain.cursorWait(false);
}

