//<script>
function SIAlert() {
}

SIAlert.init = function() {
    SIWindow.init(false);
    SIWindow.setFontsToMatchDPI();

    var elem = document.getElementById('title');
    var aTitle = (dialogArguments && SIConfig[dialogArguments.title]) ? SIConfig[dialogArguments.title] : SIConfig.appName;
    elem.innerHTML = aTitle;
    document.title = aTitle;

    SIButton.createClipped("closebox", SIAlert.noAction);
    
    if (dialogArguments.yesAction) { 
        SIButton.createClipped(dialogArguments.yesAction, SIAlert.yesAction);
        var elem = document.getElementById(dialogArguments.yesAction);
        elem.style.visibility = 'visible';
        var elem = document.getElementById('_'+dialogArguments.yesAction);
        SIWindow.focusButton(elem);
    }
    if (dialogArguments.noAction) { 
        SIButton.createClipped(dialogArguments.noAction, SIAlert.noAction);
        var elem = document.getElementById(dialogArguments.noAction);
        elem.style.visibility = 'visible';
        var elem = document.getElementById('_'+dialogArguments.noAction);
        SIWindow.focusButton(elem);
    }
    
    var elem = document.getElementById('content');
    elem.innerHTML = dialogArguments.data;

    if (dialogArguments.addHelp) {
        elem.innerHTML += "<br><br><a id=helpLink class=link>" + SIConfig.alertHelpLink + "</a>";
        setTimeout('SIAlert.finishLink()',5);
    } 
}

SIAlert.finishLink = function() {
    var aTag = document.getElementById('helpLink');
    aTag.target = '_self';
    aTag.href = 'javascript:void';
    aTag.onkeypress = SIAlert.handleLink; 
    aTag.onclick = SIAlert.handleLink; 
}

SIAlert.yesAction = function() {
    window.returnValue = "1";
    window.close();
}

SIAlert.noAction = function() {
    window.returnValue = "0";
    window.close();
}

SIAlert.handleLink = function() {
    if (event.keyCode == 13 || event.type == 'click') {
        SIAlert.alert("close", null, "alertHelpTitle", SIConfig["alertNeedHelp"]);
    }
    return  false;
}

SIAlert.openHelpDialog = function() {
    
}

SIAlert.alert = function(yesButton, noButton, titleID, content) {
    var result = window.showModalDialog('dlg-alert.htm',{dpiX:dialogArguments.dpiX,yesAction:yesButton, noAction:noButton, title:titleID, data:content,addHelp:false},
        "dialogHeight: 234px; dialogWidth: 321px; center: Yes; help: No; resizable: No; status: No;unadorned:Yes");
    return result;
}
