//<script>
function SIInfoDialog() {
}

SIInfoDialog.init = function() {
    SIWindow.init(false);
    SIWindow.setFontsToMatchDPI();
    var elem = document.getElementById('title');
    var aTitle = (dialogArguments && dialogArguments.title) ? dialogArguments.title : SIConfig.appName;
    elem.innerHTML = aTitle;
    document.title = aTitle;

    SIButton.createClipped("closebox", SIInfoDialog.noAction);
    SIButton.createClipped("no", SIInfoDialog.noAction);
    var elem = document.getElementById('_no');
    SIWindow.focusButton(elem);

    if (dialogArguments && dialogArguments.type == 'glossary') {
        SIInfoDialog.showGlossary(dialogArguments.frame);
    }
    else if (dialogArguments && dialogArguments.type == 'info') {
        SIInfoDialog.showInfo(dialogArguments.data);
    }
}




SIInfoDialog.noAction = function() {
    window.returnValue = '0';
    window.close();
}

SIInfoDialog.showGlossary = function(frame) {  
    var elem = document.getElementById('content');
    var theComposer = HTMLComposer.create(elem.innerHTML, 'glossary');
    var block1Composer = theComposer.getTokenBlock('RowBlock');
    var terms = SIGlossary[frame];
    for (var i=0; i < terms.length-1; i++) {
        term = terms[i];
        if (!(i % 2)) {
            var token = 'whiteValue';
            var otherBlock = 'BlueBlock';
        }
        else {
            var token = 'blueValue';
            var otherBlock = 'WhiteBlock';
        }
        block1Composer.replaceTokenBlock(otherBlock, null);
        block1Composer.replaceToken(token, '<span class=label1>' + term.term + ':</span> ' + term.def);
        block1Composer.next();
    }

    elem.innerHTML = theComposer.compose();
    elem.style.display = '';  
    var elem = document.getElementById('pane');
    
}

SIInfoDialog.showInfo = function(data) {  
    var elem = document.getElementById('content');
    var theComposer = HTMLComposer.create(elem.innerHTML, 'info');
    var block1Composer = theComposer.getTokenBlock('RowBlock');
    for (var i=0; i < data.length; i++) {
        if (!(i % 2)) {
            var token = 'whiteValue';
            var otherBlock = 'BlueBlock';
        }
        else {
            var token = 'blueValue';
            var otherBlock = 'WhiteBlock';
        }
        block1Composer.replaceTokenBlock(otherBlock, null);
        block1Composer.replaceToken(token, data[i]);
        block1Composer.next();
    }

    elem.innerHTML = theComposer.compose();
    elem.style.display = '';  
   
}
