//<script>
function SIPaneTab() {
}

SIPaneTab.currentTab = 0;
SIPaneTab.tabDelta = 26;

SIPaneTab.tabHeight = 26;
SIPaneTab.tabWidth = 113;
SIPaneTab.tabLeft = 14;
SIPaneTab.tabTop = 35;
SIPaneTab.buttons = new Array();
SIPaneTab.frames = new Array();
SIPaneTab.startupDefault = 1;
SIPaneTab.tabNums = SIConfig.tabs.length - 1;
SIPaneTab.makeTabs = function() {

    var aTitles = new Array();

    var curX = SIPaneTab.tabLeft;
    var curY = SIPaneTab.tabTop;
    var startupDefault = 0;
    
    for (var i = 0;i<SIPaneTab.tabNums;i++) {
        aTitles[i] = SIConfig.tabs[i].heading;
        var img = document.createElement('IMG');

        img.id = SIConfig.tabs[i].buttonImgRoot;
        img.border = 0;
        img.mnTabInd = i;
        img.style.position = 'absolute';
        img.style.zIndex = 2000;
        
        img.style.top =  curY + 'px';
        img.style.left = curX + 'px';
        img.style.width =  SIPaneTab.tabWidth + 'px';
        img.style.height = SIPaneTab.tabHeight * 4 + 'px';
        img.style.clip = 'RECT(0, 113, 26, 0)';
        
        img.alt = aTitles[i];
        img.src = '../images/' + SIConfig.tabs[i].buttonImgRoot + '.gif';
        document.body.appendChild(img);
                
        //var frame = document.createElement('IFRAME');
        //frame.id = SIConfig.tabs[i].fileRoot;
        //frame.tabIndex = -1;
        //frame.style.position = 'absolute';
        //frame.style.visibility = 'hidden';
        //frame.style.top =  0 + 'px';
        //frame.style.left = 0 + 'px';
        //frame.style.width = '100%';
        //frame.style.height = '100%';
        //frame.src = SIConfig.tabs[i].fileRoot + '.htm';

        var frame = document.getElementById(SIConfig.tabs[i].fileRoot);
        frame.title = aTitles[i];
        //frame.frameborder = '0px';
        //frame.scrolling = 'yes';
        frame.siTabInd = i;
        frame.style.zIndex = 3000 - i;
        
        frame.frameNum = i;

        var elem = document.getElementById('frameCells');
        elem.appendChild(frame);
        SIPaneTab.frames[i] = frame;
        
        curY = curY + SIPaneTab.tabDelta;
        SIPaneTab.buttons[i] = SIButton.createClipped(img.id, SIPaneTab.handleClick, SIButton.kTypeSticky, (i==0) ? SIButton.kClicked : SIButton.kNormal);
        SIPaneTab.buttons[i].index = i;
        SIPaneTab.buttons[i].setMouseDownNotify(SIPaneTab.handleClick);
        SIPaneTab.buttons[i].setEnabled(SIConfig.tabs[i].enabled);
        if ( typeof(SIConfig.tabs[i].startup) != 'undefined') {
            SIPaneTab.startupDefault = i;
        }
    }
}

SIPaneTab.setButtonStates = function(buttonId) {
    var button = SIButton.map[buttonId];
    for (var i = 0;i<SIPaneTab.tabNums;i++) {
        SIPaneTab.buttons[i].setButtonState(button == SIPaneTab.buttons[i] );        
    }

}

SIPaneTab.handleClick = function(buttonId) {
    var button = SIButton.map[buttonId];
    SIPaneTab.setTab(button.index);
    return false;
}

SIPaneTab.currentTab = null;
SIPaneTab.setTab = function(tab) {
    var buttonId = SIPaneTab.buttons[tab].getID();
    SIPaneTab.setButtonStates( buttonId );
    var elem = document.getElementById('heading');
    elem.innerHTML = SIConfig.tabs[tab].heading;
    var theFrame = SIPaneTab.frames[tab];
    SIPaneTab.currentTab = theFrame.id;
    if (!SIMain.frameInited[theFrame.id]) {
        if (SIMain[theFrame.id]) {
            setTimeout("SIMain." + theFrame.id + "()", 1);
        }
    }
    
    var glossary = (theFrame.id == 'summary') ? 'none' : '';
    var elem = document.getElementById('glossary');
    elem.style.display = glossary;

    var copy = (theFrame.id == 'summary') ? '' : 'none';
    var elem = document.getElementById('copy');
    elem.style.display = copy;
    
    for (var i = 0;i<SIPaneTab.frames.length;i++) {
        SIPaneTab.frames[i].style.visibility = (i==tab) ? 'visible' : 'hidden';    
    }
}


