//<script>
function SIWindow() {
}

SIWindow.buttonToFocus = null;
SIWindow.ieScrollToTop = function() {
    window.scrollTo(0,0);
}

SIWindow.init = function(isMain) {
    window.onscroll = SIWindow.ieScrollToTop;

    window.document.body.onmousedown = SIWindow.handleDown;
    window.document.body.onmouseup = SIWindow.setButtonFocus;
    window.onactivate = SIWindow.setButtonFocus;
    window.document.body.onmousemove = SIWindow.handleMove;
    SIWindow.titleBarHeight = 28;
    if (isMain) {
        SIWindow.titleBarWidth = 554;
         // note override to SIMain move window here, which uses the scripthelper move
        SIWindow.moveWindow =  SIMain.moveWindow;
    }
    else {
        SIWindow.titleBarWidth = 300;
    }
}

SIWindow.moveWindow = function(top, left) {
    window.dialogTop = top + 'px';
    window.dialogLeft = left + 'px';
}

SIWindow.handleMove = function() {
    if (event.button == 1 && SIWindow.isDragging) {
        var top =  event.screenY - SIWindow.mouseY;
        var left =  event.screenX - SIWindow.mouseX;
        SIWindow.moveWindow(top, left);
    }
    else if (SIWindow.isDragging) {
        SIWindow.isDragging = false;
        window.document.body.releaseCapture();
    }
}

SIWindow.mouseX = 0;
SIWindow.mouseY = 0;
SIWindow.isDragging = false;
SIWindow.handleDown = function() {
    SIWindow.mouseX = event.clientX;
    SIWindow.mouseY = event.clientY;
    if (SIWindow.mouseX < SIWindow.titleBarWidth && SIWindow.mouseY < SIWindow.titleBarHeight) {
        SIWindow.isDragging = true;
        window.document.body.setCapture();
    }
}

SIWindow.setButtonFocus = function() {
    if (SIWindow.buttonToFocus) {
        SIWindow.buttonToFocus.focus();
    }
}

SIWindow.focusButton = function(elem) {
    SIWindow.buttonToFocus = elem;
    elem.focus();
}

SIWindow.setFontsToMatchDPI = function() {
    if (typeof(screen.deviceXDPI) != 'undefined') {
        if (screen.deviceXDPI != screen.logicalXDPI) {
            return; // IE is set to scale, so do nothing
        }
    }
    
    var dpiX = null; 
    
    if ( (typeof(dialogArguments) != 'undefined') && (typeof(dialogArguments.dpiX) != 'undefined') ) {
        var dpiX = dialogArguments.dpiX;
    }
    else if ( typeof(SIMain.dpiX) != 'undefined') {
        var dpiX = SIMain.dpiX;
    }
    else {
        return;
    }

    if (dpiX == 96) {
        return; // already 96 dpi, so do nothing
    }

    var styles = document.styleSheets[0].rules;
    for (var i = 0; i < styles.length; i++) {
        var fSize = styles[i].style.fontSize;
        if (fSize != "") {
            styles[i].style.fontSize = parseInt(fSize) * (96 / dpiX) + 'pt';
        }
    }
}
